/* 
   The JitterBug bug tracking system
   utility functions

   Copyright (C) Andrew Tridgell 1997

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "config.h"
#include "includes.h"
#include "jconfig.h"
#include "html.h"
#include "version.h"

struct message_info {
	size_t size;
	int loaded;
	int private;
	char *from;
	char *subject;
	char *date;
	char *raw;
};

#define DEBUG_COMMENT(txt) printf("<!==  Debug:        " #txt "==>\n")

#include "proto.h"

#define NS(s) ((s)?(s):"(NULL)")

enum mtype {MTYPE_ALL=0, MTYPE_PENDING=1, MTYPE_REPLIED=2, MTYPE_UNREPLIED=3};

#ifdef OSSP_PATCHES
#define OSSP_PATCH_FORWARDPREFIX
#define OSSP_PATCH_FORWARDAPPROVE
#define OSSP_PATCH_FORWARDREPLIES
#define OSSP_PATCH_RECEIVEPREFIX
#define OSSP_PATCH_MIMETYPE
#define OSSP_PATCH_SIGHANDLE
#define OSSP_PATCH_REMOTEREQUEST
#define OSSP_PATCH_SANITY
#define OSSP_PATCH_COSMETICS
#define OSSP_PATCH_BETTERPRNUM
#define OSSP_PATCH_ARGV
#endif

